/** SGX

The   sss    gggg x   x   
     s      g      x x    Engine
      sss   g  gg   x
         s  g   g  x x          Copyright 1995-2009.
     ssss    gggg x   x         Steven Goodwin. All Rights Reserved.
    
This version has been released under the GNU Public License v2.0.

Please see the license files for details.

File: sgx/include/sgx/gui/static_image.hpp

*/

#ifndef SGX_CORE_GUI_STATIC_IMAGE_HPP
#define SGX_CORE_GUI_STATIC_IMAGE_HPP	1

class sgxGUIStaticImageParams {
public:
	typedef enum {
		eImage,
		eTileArea,
		eSurroundArea,
		eHollowSurround,
	} tStyle;

	sgxGUIStaticImageParams(const CSGXTexture *pTexture=NULL, const tUINT32 region=0, const tStyle style=sgxGUIStaticImageParams::eImage, const sgxColorRGBA &color=sgxColorRGBA::White, const tUINT32 w=0, const tUINT32 h=0);

	const CSGXTexture *	m_pTexture;
	tUINT32				m_Region;
	tStyle				m_Style;
	tUINT32				m_Width, m_Height;
	sgxColorRGBA		m_Color;
};

class sgxGUIStaticImage : public sgxWidget {
public:
	const CSGXTexture *		getTexture() const;
	tUINT32					getTextureRegion() const;
	void					setTextureRegion(const tUINT32 region);

protected:
	sgxGUIStaticImage(const tINT32 x, const tINT32 y, const sgxGUIStaticImageParams &params);
	virtual tBOOL	draw(CSGXDrawSurface *pSurface, const tINT32 offsetX, const tINT32 offsetY) const;
	virtual void	getArea(sgxRect2i &rc) const;
	virtual void 	setSize(const tINT32 w, const tINT32 h);


	sgxGUIStaticImageParams		m_SetupParams;
	sgxGUISkinnedStaticImage *	m_pSkinParams;

	friend class CSGXGUI;
private:
};

#endif /* SGX_CORE_GUI_STATIC_IMAGE_HPP */
